#include "mcp_can.h"
#include <SPI.h>




// 6 кнопок с задней стороны руля


#define NONE      0x00
#define LEFTDOWN   0x10
#define LEFTMID   0x20
#define LEFTUP    0x08
#define RIGHTDOWN  0x04
#define RIGHTMID  0x01
#define RIGHTUP   0x02

unsigned long filterid = 0x200; // начальный ID, с которого сканируем в порт. Можно менять кнопками громкости на руле.
unsigned long rxId;
byte rear_camera=0;
byte len;
byte rxBuf[8];
char msgString[128];
byte wheelbutton = 0x0;

byte txBuf0[] = {0x00, 0x00, 0x80, 0x20, 0x50, 0xFF, 0x0C}; // включен P, мотор заведён, тормоз отпущен.
byte txBuf1[] = {0x00, 0x00, 0x84, 0x21, 0x44, 0xFF, 0x0C}; // включен D, мотор заведён, тормоз нажат.
byte txBuf2[] = {0x00, 0x00, 0x89, 0x21, 0x52, 0xFF, 0x0C}; // включен R, мотор заведён, тормоз нажат.

MCP_CAN CAN0(10); // на десятом пине CS от адаптера "в машину".
MCP_CAN CAN1(9);  // на десятом пине CS от адаптера "в радио".

void setup(){
  Serial.begin(115200);
  // инициализация CAN0 bus, baudrate: 125k@8MHz Если шина медленная, на более старых моделях,
  // надо вместо CAN_125KBPS написать CAN_83K3BPS - 83,3Kbit/s, но там хз, может и коды другие.
  if(CAN0.begin(MCP_ANY, CAN_125KBPS, MCP_8MHZ) == CAN_OK){
  Serial.print("CAN0: Init OK!\r\n");
  CAN0.setMode(MCP_NORMAL);
  } else Serial.print("CAN0: Init Fail!!!\r\n");
  
  // инициализация CAN1 bus, baudrate: 125k@8MHz Если шина медленная, на более старых моделях,
  // надо вместо CAN_125KBPS написать CAN_83K3BPS - 83,3Kbit/s но там хз, может и коды другие.
  if(CAN1.begin(MCP_ANY, CAN_125KBPS, MCP_8MHZ) == CAN_OK){
  Serial.print("CAN1: Init OK!\r\n");
  CAN1.setMode(MCP_NORMAL);
  } else Serial.print("CAN1: Init Fail!!!\r\n");
}

void loop(){  
  if(!digitalRead(2)){          // на втором пине INT от адаптера со стороны машины. Считываем, если он в LOW.
    CAN0.readMsgBuf(&rxId, &len, rxBuf);   // читаем из шины и посмотрим, пропускать ли дальше в радио.
    //canscan();                             // если ничего в монитор порта выводить не надо, можно закомментировать
    switch (rxId){
      case 0x3A3:                       // кнопки на руле
        wheelbutton=rxBuf[0];
        switch(wheelbutton){
          case RIGHTUP:
            ++filterid;
       //     rxBuf[0]=0;               // когда сканируем, расскомментировать, чтоб не работала громкость с кнопок
            sprintf(msgString, "0x%.3lX\n", filterid);
            Serial.print(msgString);
            break;
          case RIGHTDOWN:
            --filterid;
       //     rxBuf[0]=0;               // когда сканируем, расскомментировать, чтоб не работала громкость с кнопок
            sprintf(msgString, "0x%.3lX\n", filterid);
            Serial.print(msgString);
            break;
          case LEFTMID:
            rear_camera=1;             // пока не нарыл :(
       //     rxBuf[0]=0;
            break;
          case NONE:
            rear_camera=0;
          break;
        }
        break;
      case 0x20E:
        if(rxBuf[4]!='P' && rxBuf[4]!='R'){         // если не включен P или R
           memcpy(rxBuf, txBuf0, 7);                // заменяем на P
        }
        if(rear_camera==1){
          memcpy(rxBuf, txBuf2, 7);                 // включается видеовход с камеры, но не включается сама камера :(
        }
        break;
      case 0x211:        // здесь передаётся так же скорость
        rxBuf[2] = 0x00; // во втором
        rxBuf[3] = 0x00; // и третьем байте всегда ставим в 0
        break;
    }
     CAN1.sendMsgBuf(rxId, 0, len, rxBuf); // отсылаем в радио
  }
  if(!digitalRead(3)){                    // на третьем пине INT от адаптера со стороны радио. 
    CAN1.readMsgBuf(&rxId, &len, rxBuf);  // Считываем, если он в LOW
   // canscan();                            // если ничего в монитор порта выводить не надо, можно закомментировать
    CAN0.sendMsgBuf(rxId, 0, len, rxBuf); // и пересылаем дальше в машину
  }
}

void canscan(){
  if(rxId == filterid){                       
      sprintf(msgString, "Standard ID: 0x%.3lX       DLC: %1d  Data:", rxId, len);
      Serial.print(msgString);
      for(byte i = 0; i<len; i++){
        sprintf(msgString, " %.2X", rxBuf[i]);
        Serial.print(msgString);
      }
      Serial.println();
  }
}


